using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using VAPL_MEAN;

namespace CS_APL_IDIOM_MEAN_OF_VECTOR_OF_NUMBERS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //Below the C# program creates an instance of the VAPL_MEAN.MEAN() VisualAPL class
            //Note that before this can be done a reference to the VAPL_MEAN() project must be included in the C# project references
            //Also note that instead of the explicit VAPL_MEAN.MEAN() syntax the VAPL_MEAN. is not necessary because of the using VAPL_MEAN; statement in the directives section of this C# program
            MEAN myMEAN = new MEAN();

           //Below is an example of validation done in C#     
            if ("" == textBox1.Text)
            {
                MessageBox.Show("No numbers entered!");
            }
            //Below is an example of validation done in VisualAPL
            else if(!myMEAN.ALL_NUMERIC(textBox1.Text))
            {
                MessageBox.Show("Only numbers may be entered!");
            }
            else
            {
                //Below the program uses the public methods exposed by the VAPL_MEAN_MEAN() class
                //CSTDV converts the user-entered character string in the textBox1.Text property value to a vector of floating point IEEE double precision floating point numbers
                double[] DV = (double[])myMEAN.CSTDV(textBox1.Text);
                
                //ARITHMETIC_MEAN calculates the arithmetic mean of the vector of numbers represented by the user entry in textBox1.Text and converts this value to a text string and puts the string value into textBox2.Text property value
                double AM = (double)myMEAN.ARITHMETIC_MEAN(DV);
                textBox2.Text = AM.ToString();
                
                double GM = (double)myMEAN.GEOMETRIC_MEAN(DV);
                textBox3.Text = GM.ToString();

                //MODE calculates the most frequent value in the user-entered vector of numbers
                //Note that the MODE can contain more than one value
                double[] Mode = (double[])myMEAN.MODE(DV);
                //CDVTS converts the values(s) in the MODE() method result to a text string and puts it into the textBox4.Text property value
                textBox4.Text = (string)myMEAN.CDVTS(Mode);
                
                double RMS = (double)myMEAN.RMS_MEAN(DV);
                textBox5.Text = RMS.ToString();
                double MR = (double)myMEAN.MID_RANGE(DV);
                textBox6.Text = MR.ToString();
                double[] UVS = (double[])myMEAN.UNIQUE(DV);
                textBox7.Text = (string)myMEAN.CDVTS(UVS);
                double MEDIAN = (double)myMEAN.MEDIAN(DV);
                textBox8.Text = MEDIAN.ToString();

                double[] SORT_I = (double[])myMEAN.SORT_INCR(DV);
                textBox9.Text = (string)myMEAN.CDVTS(SORT_I);
                double[] SORT_D = (double[])myMEAN.SORT_DECR(DV);
                textBox10.Text = (string)myMEAN.CDVTS(SORT_D);
                double MAX = (double)myMEAN.MAX_VAL(DV);
                textBox11.Text = MAX.ToString();
                double MIN = (double)myMEAN.MIN_VAL(DV);
                textBox12.Text = MIN.ToString();

            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            MessageBox.Show("2nd button");
            //The purpose of this function is to illustrate that additional functions can be incorporated into the application's main form
        }
    }
}